
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_ERROR_STATISTICS_H
#define PG_ERROR_STATISTICS_H

#include "base/LogObj.h"

class Error;
class ErrorRec;
class ErrorHash;

// detailed error histogram (via hash of occured errors)
class ErrorStat: public LogObj {
	public:
		ErrorStat();
		virtual ~ErrorStat();

		void reset();
		int count() const { return theCount; }
		int count(const Error &e) const;

		// returns whther a report is expected
		bool record(const Error &e, ErrorRec *&rec, int count = 1);

		void add(const ErrorStat &s);
		ErrorStat &operator =(const ErrorStat &es);

		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

		ostream &print(ostream &os, const String &pfx) const;

	protected:
		void newHash();

	protected:
		ErrorHash *theHash;
		int theCount;            // total number of errors
};

#endif
