
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "base/ILog.h"
#include "base/OLog.h"
#include "base/TmSzStat.h"


TmSzStat::TmSzStat() {
	reset();
}

void TmSzStat::reset() {
	theTm.reset();
	theSz.reset();
}

OLog &TmSzStat::store(OLog &log) const {
	return log << theTm << theSz;
}

ILog &TmSzStat::load(ILog &log) {
	return log >> theTm >> theSz;
}

TmSzStat &TmSzStat::operator +=(const TmSzStat &ts) {
	theTm += ts.theTm;
	theSz += ts.theSz;
	return *this;
}

ostream &TmSzStat::print(ostream &os, const String &pfx) const {
	theTm.print(os, pfx + "rptm.");
	theSz.print(os, pfx + "size.");
	return os;
}
