
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "base/OLog.h"
#include "base/ILog.h"
#include "runtime/httpHdrs.h"
#include "client/ServerRep.h"


ServerRep::ServerRep(const NetAddr &anAddr, int aHostIdx): 
	theAddr(anAddr), theHostIdx(aHostIdx), theSrvIdx(-1),
	theAccCount(0) {
}

void ServerRep::syncSrvInfo(const RepHdr &rep) {
	theAccCount++;
}

void ServerRep::store(OLog &log) const {
	log
		<< theAddr
		<< theId
		<< theAccCount
		;
}

void ServerRep::load(ILog &log) {
	log
		>> theAddr
		>> theId
		>> theAccCount
		;
}
