
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_BENCH_SIDE_SYMBOL_H
#define PGL_BENCH_SIDE_SYMBOL_H

#include "xstd/Array.h"
#include "xstd/NetAddr.h"
#include "pgl/PglRecSym.h"

class String;
class IntSym;
class NetAddrSym;
class PglArraySym;
class BenchSym;

// bench side configuration information (as in "client side" of the bench)
class BenchSideSym: public RecSym {
	public:
		BenchSideSym();
		BenchSideSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		const BenchSym *bench() const { return theBench; }
		void bench(const BenchSym *aBench) const { theBench = aBench; }

		bool hosts(Array<NetAddr *> &addrs) const;
		bool hostCount(int &count) const;
		NetAddr addrMask() const;
		NetAddrSym* addrMaskSym() const;
		bool maxHostLoad(double &load) const;
		bool maxAgentLoad(double &load) const;

		IntSym *hostCount() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

	protected:
		mutable const BenchSym *theBench; // set by the bench
};

#endif
