
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_HOSTS_BASED_SYMBOL_H
#define PG_HOSTS_BASED_SYMBOL_H

#include "xstd/Array.h"
#include "pgl/PglRecSym.h"
#include "xstd/NetAddr.h"

class NetAddrSym;

// base class for robot and server symbols
class HostsBasedSym: public RecSym {
	public:
		HostsBasedSym(const String &aType);
		HostsBasedSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		int hostCount() const;
		NetAddrSym *host(int idx) const;

		bool addresses(Array<NetAddrSym*> &addrs) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
