
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/h/math.h"

#include "pgl/PglExprSym.h"


bool ExpressionSym::isA(const String &type) const {
	return SynSym::isA(type) || type == "Expression";
}

ExpressionSym *ExpressionSym::unOper(const String &op) const {
	cerr << theLoc << "type `" << type() 
		<< "' has no unary operator `" << op << "'" << endl << xexit;
	return 0;
}


ExpressionSym *ExpressionSym::bnOper(const String &op, const SynSym &exp) const {
	cerr << theLoc << "binary operator `" << op 
		<< "' cannot be applied to types `" << type() 
		<< "' and `" << exp.type() << "'" << endl << xexit;
	return 0;
}

void ExpressionSym::checkDenom(int val) const {
	if (val == 0)
		cerr << theLoc << "denominator is zero" << endl << xexit;
}

void ExpressionSym::checkDenom(double val) const {
	if (fabs(val) < 1e-8)
		cerr << theLoc << "denominator is "
			<< (val ? "[virtually]" : "")
			<< " zero" << endl << xexit;
}
