
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/h/math.h"
#include "xstd/h/iostream.h"
#include "xstd/h/strstream.h"

#include "xstd/String.h"
#include "pgl/PglStringSym.h"
#include "pgl/PglArraySym.h"
#include "pgl/PglNetAddrRange.h"
#include "pgl/BenchSym.h"
#include "pgl/PolyMix4AsSym.h"


PolyMix4AsSym::PolyMix4AsSym(): VerFourAsSym("PolyMix4As", new PglRec) {
	kind("PolyMix-4");
}

PolyMix4AsSym::PolyMix4AsSym(const String &aType, PglRec *aRec): VerFourAsSym(aType, aRec) {
}

bool PolyMix4AsSym::isA(const String &type) const {
	return VerFourAsSym::isA(type) || type == "PolyMix4As";
}

SynSym *PolyMix4AsSym::dupe(const String &type) const {
	if (isA(type))
		return new PolyMix4AsSym(this->type(), theRec->clone());
	return VerFourAsSym::dupe(type);
}

String PolyMix4AsSym::robots(ArraySym *&addrs) const {
	return addresses(theBench->clientSide(), 0, addrs);
}

String PolyMix4AsSym::servers(ArraySym *&addrs) const {
	return addresses(theBench->serverSide(), 128, addrs);
}

String PolyMix4AsSym::proxies(ArraySym *&addrs) const {
	return addresses(theBench->proxySide(), 128, addrs);
}
