
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "pgl/PglPp.h"
#include "pgl/PglCtx.h"
#include "pgl/PglParser.h"

#include "xstd/gadgets.h"

int main(int argc, char **argv) {

	if (argc < 2)
		cerr << "usage: " << argv[0] << " <input_file> [include_dir] ..." << endl << xexit;

	for (int i = 2; i < argc; ++i)
		PglPp::TheDirs.append(new String(argv[i]));

	PglPp pp(argv[1]);
	PglParser parser(&pp);

	parser.parse();

	// print the final symbol table
	configureStream(cout, 2);
	PglCtx::RootCtx()->report(cout, "");

	return 0;
}
