
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_PROXY_CLIENT_XACTION_H
#define PG_PROXY_CLIENT_XACTION_H

#include "client/CltXact.h"
#include "cache/Cache.h"

class PxyCltXact: public CltXact, public CacheWriter {
	public:
		PxyCltXact() { PxyCltXact::reset(); }
		virtual void reset();

		virtual const RepHdr *origRepHdrs() const;
		virtual const UniqId &reqId() const;

		virtual void noteReaderLeft();

		virtual void cacheDistrPoint(DistrPoint *dp);
		virtual void noteAbort();

	protected:
		virtual void makeEndToEndHdrs(ostream &os);
		virtual void consume(Size size);
		virtual void firstHandSync();
		virtual void newState(State aState);

		Cache *cache();
};

#endif

