
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "base/ILog.h"
#include "base/OLog.h"
#include "runtime/StatPhase.h"
#include "runtime/Goal.h"

#include "pgl/GoalSym.h"


Goal::Goal() {
}

void Goal::configure(const GoalSym *cfg) {
	Assert(cfg);
	theDuration = cfg->duration();
	cfg->xactCount(theXactCnt);
	cfg->fillSize(theFillSz);
	cfg->errs(theErrs.theRatio, theErrs.theCount);
}

// XXX: magic constant in "theXactCnt >= 1000"
bool Goal::reached(const StatPhase &ph) const {
	return // meeting one sub-goal is enough!
		(theDuration >= 0 && theDuration <= ph.duration()) ||
		(theXactCnt >= 0 && theXactCnt <= ph.xactCnt()) ||
		(theFillSz >= 0 && theFillSz <= ph.fillSz()) ||
		(theErrs.count() >= 0 && theErrs.count() <= ph.errCnt()) ||
		(theXactCnt >= 1000 && theErrs.ratio() >= 0 && theErrs.ratio() <= ph.errRatio())
		;
}
