
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "xstd/h/iomanip.h"

#include "xstd/Rnd.h"
#include "base/RndPermut.h"
#include "runtime/HotSet.h"


HotSet::HotSet(): thePos(0) {
}

void HotSet::reset() {
	thePos = 0;
}

void HotSet::syncPos(int size, int wss) {
	if (size && wss != 0) {
		if (wss < 0) {
			// the best we can do w/o storing size-at-change?
			thePos = size/2; 
		} else
		if (thePos <= size - wss) {
			// random position within working set
			Assert(wss <= size);
			RndGen rng(RndPermut(thePos, rndHotSetPos));
			thePos = size - rng(0, wss);
		}
	}
	Assert(0 <= thePos && thePos <= size);
}
