
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef SHARED_OPTS
#define SHARED_OPTS

#include "base/opts.h"
#include "base/polyOpts.h"

// options shared by client and server sides
class SharedOpts: public OptGrp {
	public:
		SharedOpts(); // defaults

		virtual bool validate() const;
		
	public:
		HelpOpt theHelpOpt;
		VersionOpt theVersOpt;
		HostTypeOpt theHostTypeOpt;

		IntOpt theVerbLevel;
		DumpFlagsOpt theDumpFlags;
		SizeOpt theDumpSize;
		NetAddrOpt theNotifAddr;
		StrOpt theRunLabel;

		IntOpt theFDLimit;

		StrOpt theCfgFileName;
		StrArrOpt theCfgDirs;

		StrOpt theConsFileName;
		StrOpt theLogFileName;
		SizeOpt theLogBufSize;
		StrOpt theSmplLogFileName;
		SizeOpt theSmplLogBufSize;

		TimeOpt theStatCycleLen;
		BoolOpt doSyncPhases;

		FileScanOpt theFileScanner;
		IntOpt thePrioritySched;

		StrArrOpt theFakeHosts;

		TimeOpt theIdleTout;

		IntOpt theRngSeed;
		BoolOpt useUniqueWorld;
};

extern SharedOpts TheOpts;

#endif
