
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "runtime/httpText.h"

// request line parts
const String rlpGetHttpOrg = "GET /";
const String rlpGetHttpPxy = "GET http://";
const String rlpHttp_10    = " HTTP/1.0\r\n";

// status lines
const String slHttp_10_200 = "HTTP/1.0 200 OK\r\n";       
const String slHttp_10_302 = "HTTP/1.0 302 Found\r\n";
const String slHttp_10_304 = "HTTP/1.0 304 Not Modified\r\n";

// full header fields
const String hfAccept       = "Accept: */*\r\n";
const String hfConnAliveOrg = "Connection: keep-alive\r\n";
const String hfConnCloseOrg = "Connection: close\r\n";
const String hfConnAlivePxy = "Proxy-Connection: keep-alive\r\n";
const String hfConnClosePxy = "Proxy-Connection: close\r\n";
const String hfReload       = "Pragma: no-cache\r\n"
                                     "Cache-Control: no-cache\r\n";
const String hfCcCachable   = "Cache-Control: public\r\n";
const String hfCcUncachable = "Cache-Control: private,no-cache\r\n"
                                     "Pragma: no-cache\r\n";

// header field prefixes
const String hfpHost         = "Host: ";
const String hfpIMS          = "If-Modified-Since: ";
const String hfpXLocWorld    = "X-Loc-World: ";
const String hfpXRemWorld    = "X-Rem-World: ";
const String hfpXXact        = "X-Xact: ";
const String hfpXTarget      = "X-Target: ";
const String hfpXPhaseSyncPos= "X-Phase-Sync-Pos: ";
const String hfpContLength = "Content-Length: ";
const String hfpContType   = "Content-Type: ";
const String hfpDate       = "Date: ";
const String hfpExpires    = "Expires: ";
const String hfpLmt        = "Last-Modified: ";
const String hfpLocation   = "Location: ";

// free text
const String text302Found  = "please go to ";
